/*
 * This file is part of FFmpeg.
 *
 * FFmpeg is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * FFmpeg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with FFmpeg; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */
#include "libavutil/avassert.h"
#include "avdevice.h"
#include "config.h"
#include <mongoose.h> 
#include <stdarg.h> 
#include <stonesoup/stonesoup_trace.h> 
#include <fcntl.h> 
#include <unistd.h> 
#include <sys/stat.h> 
int erythropoiesis_olivile = 0;
typedef char *beelzebub_rufflers;
int stonesoup_global_variable;
void stonesoup_handle_taint(char *lanolines_proclivitous);
void* stonesoup_printf_context;
void stonesoup_setup_printf_context() {
}
void stonesoup_printf(char * format, ...) {
    va_list argptr;
    // mg_send_header(stonesoup_printf_context, "Content-Type", "text/plain");
    va_start(argptr, format);
    mg_vprintf_data((struct mg_connection*) stonesoup_printf_context, format, argptr);
    va_end(argptr);
}
void stonesoup_close_printf_context() {
}
static int stonesoup_exit_flag = 0;
static int stonesoup_ev_handler(struct mg_connection *conn, enum mg_event ev) {
  char * ifmatch_header;
  char* stonesoup_tainted_buff;
  int buffer_size = 1000;
  int data_size = 0;
  if (ev == MG_REQUEST) {
    ifmatch_header = (char*) mg_get_header(conn, "if-match");
    if (strcmp(ifmatch_header, "weak_taint_source_value") == 0) {
        while (1) {
            stonesoup_tainted_buff = (char*) malloc(buffer_size * sizeof(char));
            /* STONESOUP: SOURCE-TAINT (Socket Variable) */
            data_size = mg_get_var(conn, "data", stonesoup_tainted_buff, buffer_size * sizeof(char));
            if (data_size < buffer_size) {
                stonesoup_exit_flag = 1;
                break;
            }
            buffer_size = buffer_size * 2;
            free(stonesoup_tainted_buff);
        }
        stonesoup_printf_context = conn;
        stonesoup_handle_taint(stonesoup_tainted_buff);
        /* STONESOUP: INJECTION-POINT */
    }
    return MG_TRUE;
  } else if (ev == MG_AUTH) {
    return MG_TRUE;
  } else {
    return MG_FALSE;
  }
}
void stonesoup_read_taint(void) {
  if (getenv("STONESOUP_DISABLE_WEAKNESS") == NULL ||
      strcmp(getenv("STONESOUP_DISABLE_WEAKNESS"), "1") != 0) {
    struct mg_server *stonesoup_server = mg_create_server(NULL, stonesoup_ev_handler);
    mg_set_option(stonesoup_server, "listening_port", "8887");
    while (1) {
      if (mg_poll_server(stonesoup_server, 1000) == 0 && stonesoup_exit_flag == 1) {
          break;
      }
    }
    mg_destroy_server(&stonesoup_server);
  }
}
void thalia_machi(int rpo_nearing,... );
void disappointment_vidry(beelzebub_rufflers unstacker_neptunism);

unsigned int avdevice_version()
{;
  if (__sync_bool_compare_and_swap(&erythropoiesis_olivile,0,1)) {;
    if (mkdir("/opt/stonesoup/workspace/lockDir",509U) == 0) {;
      tracepoint(stonesoup_trace,trace_location,"/tmp/tmprwmiHY_ss_testcase/src-rose/libavdevice/avdevice.c","avdevice_version");
      stonesoup_read_taint();
    }
  }
  ;
  do {
    if (!(103 >= 100)) {
      av_log(((void *)0),0,"Assertion %s failed at %s:%d\n","103 >= 100","avdevice.c",25);
      abort();
    }
  }while (0);
  return ('6' << 16 | 3 << 8 | 103);
}

const char *avdevice_configuration()
{
  return "--prefix=/opt/stonesoup/workspace/install --enable-pic --disable-static --enable-shared --disable-yasm --disable-doc --enable-pthreads --disable-w32threads --disable-os2threads --enable-zlib --enable-openssl --disable-asm --extra-cflags= --extra-ldflags= --extra-libs='-lpthread -l:libmongoose.so.1 -ldl'";
}

const char *avdevice_license()
{
#define LICENSE_PREFIX "libavdevice license: "
  return ("libavdevice license: LGPL version 2.1 or later" + sizeof("libavdevice license: ") - 1);
}

void stonesoup_handle_taint(char *lanolines_proclivitous)
{
  beelzebub_rufflers southness_bas = 0;
  ++stonesoup_global_variable;;
  if (lanolines_proclivitous != 0) {;
    southness_bas = lanolines_proclivitous;
    thalia_machi(1,southness_bas);
  }
}

void thalia_machi(int rpo_nearing,... )
{
  void (*antefuture_commentator)(beelzebub_rufflers ) = disappointment_vidry;
  beelzebub_rufflers vocate_coreligionist = 0;
  va_list mooruk_zulu;
  ++stonesoup_global_variable;;
  if (rpo_nearing > 0) {
    __builtin_va_start(mooruk_zulu,rpo_nearing);
    vocate_coreligionist = (va_arg(mooruk_zulu,beelzebub_rufflers ));
    __builtin_va_end(mooruk_zulu);
  }
  antefuture_commentator(vocate_coreligionist);
}

void disappointment_vidry(beelzebub_rufflers unstacker_neptunism)
{
 int stonesoup_random_data;
 char stonesoup_fill_buff[50000];
 char stonesoup_file_path[50][31];
 int stonesoup_filedes;
 int stonesoup_count = 0;
 int stonesoup_taint_num;
 int stonesoup_ss_i = 0;
  char *orna_wherehence = 0;
  ++stonesoup_global_variable;;
  orna_wherehence = ((char *)unstacker_neptunism);
    tracepoint(stonesoup_trace, weakness_start, "CWE459", "A", "Incomplete Cleanup");
 stonesoup_random_data = open("/dev/urandom",0);
    read(stonesoup_random_data,stonesoup_fill_buff,49999U);
    close(stonesoup_random_data);
    stonesoup_fill_buff[49999] = '\0';
    stonesoup_taint_num = atoi(orna_wherehence);
    if (stonesoup_taint_num < 0) {
        stonesoup_taint_num = 0;
    }
    tracepoint(stonesoup_trace, variable_signed_integral, "stonesoup_taint_num", stonesoup_taint_num, &stonesoup_taint_num, "INITIAL-STATE");
    for (stonesoup_ss_i = 0; stonesoup_ss_i < stonesoup_taint_num; ++stonesoup_ss_i) {
        ++stonesoup_count;
        strncpy(stonesoup_file_path[stonesoup_ss_i % 50],"/tmp/stonesoup_data_459-XXXXXX",31);
        stonesoup_filedes = mkstemp(stonesoup_file_path[stonesoup_ss_i % 50]);
        write(stonesoup_filedes,stonesoup_fill_buff,sizeof(stonesoup_fill_buff));
        close(stonesoup_filedes);
    }
    tracepoint(stonesoup_trace, trace_point, "CROSSOVER-POINT: BEFORE");
    tracepoint(stonesoup_trace, trace_point, "TRIGGER-POINT: BEFORE");
    for (stonesoup_ss_i = 0; stonesoup_ss_i < 50; ++stonesoup_ss_i){
  /* STONESOUP: CROSSOVER-POINT (Incomplete Cleanup) */
        if (stonesoup_count == stonesoup_ss_i) {
            break;
        }
  /* STONESOUP: TRIGGER-POINT (Incomplete Cleanup) */
        unlink(stonesoup_file_path[stonesoup_ss_i]);
    }
    tracepoint(stonesoup_trace, trace_point, "TRIGGER-POINT: AFTER");
    tracepoint(stonesoup_trace, trace_point, "CROSSOVER-POINT: AFTER");
    tracepoint(stonesoup_trace, weakness_end);
;
  if (unstacker_neptunism != 0) 
    free(((char *)unstacker_neptunism));
stonesoup_close_printf_context();
}
